import * as fs from "node:fs"
import logger from "./logger"

export function createDirsIfMissing(...directories: string[]): void {
  directories.forEach(createDirIfMissing)
}

export function createDirIfMissing(directory: string): void {
  if (!fs.existsSync(directory)) {
    logger.info(`Missing '${directory}', creating...`)
    fs.mkdirSync(directory, { recursive: true })
  }
}
